diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy.cc ns-3.42/src/wifi/model/wifi-phy.cc
--- ns-3.41/src/wifi/model/wifi-phy.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy.cc	2024-05-29 15:29:47.212073800 -0700
@@ -47,6 +47,13 @@
 
 #include <algorithm>
 
+#undef NS_LOG_APPEND_CONTEXT
+#define NS_LOG_APPEND_CONTEXT                                                                      \
+    WIFI_PHY_NS_LOG_APPEND_CONTEXT(                                                                \
+        (m_device && (m_device->GetNPhys() > m_phyId) && m_device->GetPhy(m_phyId)                 \
+             ? m_device->GetPhy(m_phyId)                                                           \
+             : nullptr))
+
 namespace ns3
 {
 
@@ -334,6 +341,11 @@
                             "has been dropped by the device during reception",
                             MakeTraceSourceAccessor(&WifiPhy::m_phyRxDropTrace),
                             "ns3::Packet::TracedCallback")
+            .AddTraceSource("PhyRxPpduDrop",
+                            "Trace source indicating a ppdu "
+                            "has been dropped by the device during reception",
+                            MakeTraceSourceAccessor(&WifiPhy::m_phyRxPpduDropTrace),
+                            "ns3::WifiPhy::PhyRxPpduDropTracedCallback")
             .AddTraceSource("MonitorSnifferRx",
                             "Trace source simulating a wifi device in monitor mode "
                             "sniffing all received frames",
@@ -343,12 +355,17 @@
                             "Trace source simulating the capability of a wifi device "
                             "in monitor mode to sniff all frames being transmitted",
                             MakeTraceSourceAccessor(&WifiPhy::m_phyMonitorSniffTxTrace),
-                            "ns3::WifiPhy::MonitorSnifferTxTracedCallback");
+                            "ns3::WifiPhy::MonitorSnifferTxTracedCallback")
+            .AddTraceSource("SignalTransmission",
+                            "Trace start of signal transmission",
+                            MakeTraceSourceAccessor(&WifiPhy::m_signalTransmissionCb),
+                            "ns3::SpectrumWifiPhy::SignalTransmissionCallback");
     return tid;
 }
 
 WifiPhy::WifiPhy()
-    : m_txMpduReferenceNumber(0xffffffff),
+    : m_phyId(0),
+      m_txMpduReferenceNumber(0xffffffff),
       m_rxMpduReferenceNumber(0xffffffff),
       m_endPhyRxEvent(),
       m_endTxEvent(),
@@ -409,8 +426,6 @@
 {
     NS_LOG_FUNCTION(this);
 
-    Reset();
-
     m_device = nullptr;
     m_mobility = nullptr;
     m_frameCaptureModel = nullptr;
@@ -425,6 +440,9 @@
     m_random = nullptr;
     m_state = nullptr;
 
+    Reset();
+
+    // this should be done after calling the Reset function
     for (auto& phyEntity : m_phyEntities)
     {
         phyEntity.second = nullptr;
@@ -479,13 +497,13 @@
 WifiPhy::SetRxSensitivity(double threshold)
 {
     NS_LOG_FUNCTION(this << threshold);
-    m_rxSensitivityW = DbmToW(threshold);
+    m_rxSensitivityDbm = threshold;
 }
 
 double
 WifiPhy::GetRxSensitivity() const
 {
-    return WToDbm(m_rxSensitivityW);
+    return m_rxSensitivityDbm;
 }
 
 void
@@ -628,8 +646,22 @@
 }
 
 void
+WifiPhy::SetPhyId(uint8_t phyId)
+{
+    NS_LOG_FUNCTION(this << phyId);
+    m_phyId = phyId;
+}
+
+uint8_t
+WifiPhy::GetPhyId() const
+{
+    return m_phyId;
+}
+
+void
 WifiPhy::SetInterferenceHelper(const Ptr<InterferenceHelper> helper)
 {
+    NS_LOG_FUNCTION(this << helper);
     m_interference = helper;
     m_interference->SetNoiseFigure(DbToRatio(m_noiseFigureDb));
     m_interference->SetNumberOfReceiveAntennas(m_numberOfAntennas);
@@ -638,6 +670,7 @@
 void
 WifiPhy::SetErrorRateModel(const Ptr<ErrorRateModel> model)
 {
+    NS_LOG_FUNCTION(this << model);
     NS_ASSERT(m_interference);
     m_interference->SetErrorRateModel(model);
 }
@@ -751,8 +784,7 @@
 void
 WifiPhy::AddStaticPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
 {
-    NS_LOG_FUNCTION(modulation);
-    NS_ASSERT_MSG(GetStaticPhyEntities().find(modulation) == GetStaticPhyEntities().end(),
+    NS_ASSERT_MSG(!GetStaticPhyEntities().contains(modulation),
                   "The PHY entity has already been added. The setting should only be done once per "
                   "modulation class");
     GetStaticPhyEntities()[modulation] = phyEntity;
@@ -762,7 +794,7 @@
 WifiPhy::AddPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity)
 {
     NS_LOG_FUNCTION(this << modulation);
-    NS_ABORT_MSG_IF(GetStaticPhyEntities().find(modulation) == GetStaticPhyEntities().end(),
+    NS_ABORT_MSG_IF(!GetStaticPhyEntities().contains(modulation),
                     "Cannot add an unimplemented PHY to supported list. Update the former first.");
     NS_ASSERT_MSG(m_phyEntities.find(modulation) == m_phyEntities.end(),
                   "The PHY entity has already been added. The setting should only be done once per "
@@ -1617,6 +1649,13 @@
 }
 
 void
+WifiPhy::NotifyRxPpduDrop(Ptr<const WifiPpdu> ppdu, WifiPhyRxfailureReason reason)
+{
+    NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), reason);
+    m_phyRxPpduDropTrace(ppdu, reason);
+}
+
+void
 WifiPhy::NotifyMonitorSniffRx(Ptr<const WifiPsdu> psdu,
                               uint16_t channelFreqMhz,
                               WifiTxVector txVector,
@@ -1777,11 +1816,19 @@
     Time txDuration = CalculateTxDuration(psdus, txVector, GetPhyBand());
 
     bool noEndPreambleDetectionEvent = true;
-    for (const auto& it : m_phyEntities)
+    for (const auto& [mc, entity] : m_phyEntities)
     {
-        noEndPreambleDetectionEvent &= it.second->NoEndPreambleDetectionEvents();
+        noEndPreambleDetectionEvent =
+            noEndPreambleDetectionEvent && entity->NoEndPreambleDetectionEvents();
     }
-    if (!noEndPreambleDetectionEvent || m_currentEvent)
+    if (!noEndPreambleDetectionEvent && !m_currentEvent)
+    {
+        // PHY is in the initial few microseconds during which the
+        // start of RX has occurred but the preamble detection period
+        // has not elapsed
+        AbortCurrentReception(SIGNAL_DETECTION_ABORTED_BY_TX);
+    }
+    else if (!noEndPreambleDetectionEvent || m_currentEvent)
     {
         AbortCurrentReception(RECEPTION_ABORTED_BY_TX);
     }
@@ -1824,17 +1871,23 @@
     }
 
     m_endTxEvent =
-        Simulator::Schedule(txDuration, &WifiPhy::NotifyTxEnd, this, psdus); // TODO: fix for MU
+        Simulator::Schedule(txDuration, &WifiPhy::TxDone, this, psdus); // TODO: fix for MU
 
     StartTx(ppdu);
     ppdu->ResetTxVector();
 
     m_channelAccessRequested = false;
     m_powerRestricted = false;
+}
 
-    Simulator::Schedule(txDuration, &WifiPhy::Reset, this);
-
-    Simulator::Schedule(txDuration, &WifiPhy::SwitchMaybeToCcaBusy, this, nullptr);
+void
+WifiPhy::TxDone(const WifiConstPsduMap& psdus)
+{
+    NS_LOG_FUNCTION(this << psdus);
+    NotifyTxEnd(psdus);
+    Reset();
+    // we might have received signals during TX
+    SwitchMaybeToCcaBusy();
 }
 
 uint64_t
@@ -1855,6 +1908,16 @@
 {
     NS_LOG_FUNCTION(this);
     m_currentPreambleEvents.clear();
+    bool noEndPreambleDetectionEvent = true;
+    for (const auto& [mc, entity] : m_phyEntities)
+    {
+        noEndPreambleDetectionEvent =
+            noEndPreambleDetectionEvent && entity->NoEndPreambleDetectionEvents();
+    }
+    if (m_interference && (m_currentEvent || !noEndPreambleDetectionEvent))
+    {
+        m_interference->NotifyRxEnd(Simulator::Now(), GetCurrentFrequencyRange());
+    }
     m_currentEvent = nullptr;
     for (auto& phyEntity : m_phyEntities)
     {
@@ -1882,7 +1945,7 @@
         // TODO find a fallback PHY for receiving the PPDU (e.g. 11a for 11ax due to preamble
         // structure)
         NS_LOG_DEBUG("Unsupported modulation received (" << modulation << "), consider as noise");
-        m_interference->Add(ppdu, rxDuration, rxPowersW);
+        m_interference->Add(ppdu, rxDuration, rxPowersW, GetCurrentFrequencyRange());
         SwitchMaybeToCcaBusy();
     }
 }
@@ -1890,7 +1953,7 @@
 bool
 WifiPhy::IsReceivingPhyHeader() const
 {
-    return m_endPhyRxEvent.IsRunning();
+    return m_endPhyRxEvent.IsPending();
 }
 
 void
@@ -2122,6 +2185,14 @@
     if (reason != OBSS_PD_CCA_RESET ||
         m_currentEvent) // Otherwise abort has already been called previously
     {
+        if (reason == SIGNAL_DETECTION_ABORTED_BY_TX)
+        {
+            for (auto signalDetectEvent : m_currentPreambleEvents)
+            {
+                NotifyRxPpduDrop(signalDetectEvent.second->GetPpdu(),
+                                 SIGNAL_DETECTION_ABORTED_BY_TX);
+            }
+        }
         for (auto& phyEntity : m_phyEntities)
         {
             phyEntity.second->CancelAllEvents();
@@ -2132,7 +2203,7 @@
         {
             return;
         }
-        NotifyRxDrop(GetAddressedPsduInPpdu(m_currentEvent->GetPpdu()), reason);
+        NotifyRxPpduDrop(m_currentEvent->GetPpdu(), reason);
         if (reason == OBSS_PD_CCA_RESET)
         {
             m_state->SwitchFromRxAbort(GetChannelWidth());
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy-common.cc ns-3.42/src/wifi/model/wifi-phy-common.cc
--- ns-3.41/src/wifi/model/wifi-phy-common.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy-common.cc	2024-05-29 15:29:47.212073800 -0700
@@ -257,11 +257,13 @@
         return 20;
     case WIFI_MOD_CLASS_HT:
         return 40;
+    // NOLINTBEGIN(bugprone-branch-clone)
     case WIFI_MOD_CLASS_VHT:
     case WIFI_MOD_CLASS_HE:
         return 160;
     case WIFI_MOD_CLASS_EHT:
-        return 160; // TODO update when 320 MHz channels are supported
+        return 160; // TODO update when 320 MHz channels are supported and remove clang-tidy guards
+    // NOLINTEND(bugprone-branch-clone)
     default:
         NS_ABORT_MSG("Unknown modulation class: " << modulation);
         return 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy-common.h ns-3.42/src/wifi/model/wifi-phy-common.h
--- ns-3.41/src/wifi/model/wifi-phy-common.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy-common.h	2024-05-29 15:29:47.212073800 -0700
@@ -22,11 +22,11 @@
 #ifndef WIFI_PHY_COMMON_H
 #define WIFI_PHY_COMMON_H
 
+#include "wifi-spectrum-value-helper.h"
 #include "wifi-standards.h"
 
 #include "ns3/fatal-error.h"
 #include "ns3/ptr.h"
-#include "ns3/wifi-spectrum-value-helper.h"
 
 #include <ostream>
 
@@ -428,7 +428,8 @@
     PPDU_TOO_LATE,
     FILTERED,
     DMG_HEADER_FAILURE,
-    DMG_ALLOCATION_ENDED
+    DMG_ALLOCATION_ENDED,
+    SIGNAL_DETECTION_ABORTED_BY_TX
 };
 
 /**
@@ -489,6 +490,8 @@
         return (os << "DMG_HEADER_FAILURE");
     case DMG_ALLOCATION_ENDED:
         return (os << "DMG_ALLOCATION_ENDED");
+    case SIGNAL_DETECTION_ABORTED_BY_TX:
+        return (os << "SIGNAL_DETECTION_ABORTED_BY_TX");
     case UNKNOWN:
     default:
         NS_FATAL_ERROR("Unknown reason");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy.h ns-3.42/src/wifi/model/wifi-phy.h
--- ns-3.41/src/wifi/model/wifi-phy.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy.h	2024-05-29 15:29:47.212073800 -0700
@@ -30,6 +30,18 @@
 
 #include <limits>
 
+#define WIFI_PHY_NS_LOG_APPEND_CONTEXT(phy)                                                        \
+    {                                                                                              \
+        if (DynamicCast<const WifiPhy>(phy))                                                       \
+        {                                                                                          \
+            std::clog << "[index=" << +phy->GetPhyId() << "][channel="                             \
+                      << (phy->GetOperatingChannel().IsSet()                                       \
+                              ? std::to_string(+phy->GetOperatingChannel().GetNumber())            \
+                              : "UNKNOWN")                                                         \
+                      << "][band=" << phy->GetPhyBand() << "] ";                                   \
+        }                                                                                          \
+    }
+
 namespace ns3
 {
 
@@ -596,12 +608,26 @@
      * Public method used to fire a PhyRxDrop trace.
      * Implemented for encapsulation purposes.
      *
+     * \note This method is called also by NotifyRxPpduDrop and is left
+     * in the public API for backward compatibility reasons.  Do not
+     * call both this method and the newer NotifyRxPpduDrop().  Instead,
+     * call NotifyRxPpduDrop() and it will call this method also.
+     *
      * \param psdu the PSDU being transmitted
      * \param reason the reason the packet was dropped
      */
     void NotifyRxDrop(Ptr<const WifiPsdu> psdu, WifiPhyRxfailureReason reason);
 
     /**
+     * Public method used to fire a PhyRxPpduDrop trace.
+     * Implemented for encapsulation purposes.  This method also
+     * calls the PhyRxDrop trace.
+     *
+     * \param ppdu the PSDU being transmitted
+     * \param reason the reason the packet was dropped
+     */
+    void NotifyRxPpduDrop(Ptr<const WifiPpdu> ppdu, WifiPhyRxfailureReason reason);
+    /**
      * Public method used to fire a MonitorSniffer trace for a wifi PSDU being received.
      * Implemented for encapsulation purposes.
      * This method will extract all MPDUs if packet is an A-MPDU and will fire tracedCallback.
@@ -732,6 +758,15 @@
     typedef void (*PhyRxPayloadBeginTracedCallback)(WifiTxVector txVector, Time psduDuration);
 
     /**
+     * TracedCallback signature for start of PSDU reception events.
+     *
+     * \param txVector the TXVECTOR decoded from the PHY header
+     * \param psduDuration the duration of the PSDU
+     */
+    typedef void (*PhyRxPpduDropTracedCallback)(Ptr<const WifiPpdu> ppdu,
+                                                WifiPhyRxfailureReason reason);
+
+    /**
      * Assign a fixed random variable stream number to the random variables
      * used by this model. Return the number of streams (possibly zero) that
      * have been assigned.
@@ -987,6 +1022,20 @@
     bool GetShortPhyPreambleSupported() const;
 
     /**
+     * Set the index allocated to this PHY
+     *
+     * \param phyId the ID allocated to this PHY
+     */
+    void SetPhyId(uint8_t phyId);
+
+    /**
+     * Get the index allocated to this PHY
+     *
+     * \return the ID allocated to this PHY
+     */
+    uint8_t GetPhyId() const;
+
+    /**
      * Sets the interference helper.
      *
      * \param helper the interference helper
@@ -1207,6 +1256,15 @@
      */
     uint32_t GetSubcarrierSpacing() const;
 
+    /**
+     * Callback invoked when the PHY model starts to transmit a signal
+     *
+     * \param ppdu The PPDU being transmitted
+     * \param txVector txVector used for transmitting the PPDU
+     */
+    typedef void (*SignalTransmissionCallback)(Ptr<const WifiPpdu> ppdu,
+                                               const WifiTxVector& txVector);
+
   protected:
     void DoInitialize() override;
     void DoDispose() override;
@@ -1256,6 +1314,8 @@
      */
     void AddPhyEntity(WifiModulationClass modulation, Ptr<PhyEntity> phyEntity);
 
+    uint8_t m_phyId; //!< the index of the PHY in the vector of PHYs held by the WifiNetDevice
+
     Ptr<InterferenceHelper>
         m_interference; //!< Pointer to a helper responsible for interference computations
 
@@ -1297,6 +1357,9 @@
      */
     std::map<WifiModulationClass, Ptr<PhyEntity>> m_phyEntities;
 
+    TracedCallback<Ptr<const WifiPpdu>, const WifiTxVector&>
+        m_signalTransmissionCb; //!< Signal Transmission callback
+
   private:
     /**
      * Configure WifiPhy with appropriate channel frequency and
@@ -1362,6 +1425,12 @@
     void AbortCurrentReception(WifiPhyRxfailureReason reason);
 
     /**
+     * Callback function when a transmission is completed
+     * \param psdus the PSDUs that have been sent
+     */
+    void TxDone(const WifiConstPsduMap& psdus);
+
+    /**
      * Get the PSDU addressed to that PHY in a PPDU (useful for MU PPDU).
      *
      * \param ppdu the PPDU to extract the PSDU from
@@ -1440,6 +1509,11 @@
     TracedCallback<Ptr<const Packet>, WifiPhyRxfailureReason> m_phyRxDropTrace;
 
     /**
+     * The trace source fired when the PHY layer drops a packet it has received.
+     */
+    TracedCallback<Ptr<const WifiPpdu>, WifiPhyRxfailureReason> m_phyRxPpduDropTrace;
+
+    /**
      * A trace source that emulates a Wi-Fi device in monitor mode
      * sniffing a packet being received.
      *
@@ -1500,7 +1574,7 @@
     Time m_ackTxTime;      //!< estimated Ack TX time
     Time m_blockAckTxTime; //!< estimated BlockAck TX time
 
-    double m_rxSensitivityW;  //!< Receive sensitivity threshold in watts
+    double m_rxSensitivityDbm; //!< Receive sensitivity threshold in dBm
     double m_ccaEdThresholdW; //!< Clear channel assessment (CCA) energy detection (ED) threshold in
                               //!< watts
     double m_ccaSensitivityThresholdW; //!< Clear channel assessment (CCA) modulation and coding
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy-operating-channel.cc ns-3.42/src/wifi/model/wifi-phy-operating-channel.cc
--- ns-3.41/src/wifi/model/wifi-phy-operating-channel.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy-operating-channel.cc	2024-05-29 15:29:47.212073800 -0700
@@ -251,7 +251,7 @@
     {std::make_tuple(71, 6305, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
     {std::make_tuple(87, 6385, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
     {std::make_tuple(103, 6465, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
-    {std::make_tuple(119, 6585, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
+    {std::make_tuple(119, 6545, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
     {std::make_tuple(135, 6625, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
     {std::make_tuple(151, 6705, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
     {std::make_tuple(167, 6785, 80, WIFI_PHY_OFDM_CHANNEL, WIFI_PHY_BAND_6GHZ)},
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy-state.h ns-3.42/src/wifi/model/wifi-phy-state.h
--- ns-3.41/src/wifi/model/wifi-phy-state.h	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy-state.h	2024-05-29 15:29:47.212073800 -0700
@@ -21,18 +21,22 @@
 #ifndef WIFI_PHY_STATE_H
 #define WIFI_PHY_STATE_H
 
+#include "ns3/deprecated.h"
 #include "ns3/fatal-error.h"
 
+namespace ns3
+{
+
 /**
  * The state of the PHY layer.
  */
 /// State enumeration
-enum WifiPhyState
+enum class WifiPhyState
 {
     /**
      * The PHY layer is IDLE.
      */
-    IDLE,
+    IDLE = 0,
     /**
      * The PHY layer has sense the medium busy through the CCA mechanism
      */
@@ -71,19 +75,19 @@
 {
     switch (state)
     {
-    case IDLE:
+    case WifiPhyState::IDLE:
         return (os << "IDLE");
-    case CCA_BUSY:
+    case WifiPhyState::CCA_BUSY:
         return (os << "CCA_BUSY");
-    case TX:
+    case WifiPhyState::TX:
         return (os << "TX");
-    case RX:
+    case WifiPhyState::RX:
         return (os << "RX");
-    case SWITCHING:
+    case WifiPhyState::SWITCHING:
         return (os << "SWITCHING");
-    case SLEEP:
+    case WifiPhyState::SLEEP:
         return (os << "SLEEP");
-    case OFF:
+    case WifiPhyState::OFF:
         return (os << "OFF");
     default:
         NS_FATAL_ERROR("Invalid state");
@@ -91,4 +95,23 @@
     }
 }
 
+} // namespace ns3
+
+NS_DEPRECATED_3_42("Use WifiPhyState::IDLE instead")
+static constexpr auto IDLE = ns3::WifiPhyState::IDLE; //!< \deprecated See WifiPhyState::IDLE
+NS_DEPRECATED_3_42("Use WifiPhyState::CCA_BUSY instead")
+static constexpr auto CCA_BUSY =
+    ns3::WifiPhyState::CCA_BUSY; //!< \deprecated See WifiPhyState::CCA_BUSY
+NS_DEPRECATED_3_42("Use WifiPhyState::TX instead")
+static constexpr auto TX = ns3::WifiPhyState::TX; //!< \deprecated See WifiPhyState::TX
+NS_DEPRECATED_3_42("Use WifiPhyState::RX instead")
+static constexpr auto RX = ns3::WifiPhyState::RX; //!< \deprecated See WifiPhyState::RX
+NS_DEPRECATED_3_42("Use WifiPhyState::SWITCHING instead")
+static constexpr auto SWITCHING =
+    ns3::WifiPhyState::SWITCHING; //!< \deprecated See WifiPhyState::SWITCHING
+NS_DEPRECATED_3_42("Use WifiPhyState::SLEEP instead")
+static constexpr auto SLEEP = ns3::WifiPhyState::SLEEP; //!< \deprecated See WifiPhyState::SLEEP
+NS_DEPRECATED_3_42("Use WifiPhyState::OFF instead")
+static constexpr auto OFF = ns3::WifiPhyState::OFF; //!< \deprecated See WifiPhyState::OFF
+
 #endif /* WIFI_PHY_STATE_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/wifi/model/wifi-phy-state-helper.cc ns-3.42/src/wifi/model/wifi-phy-state-helper.cc
--- ns-3.41/src/wifi/model/wifi-phy-state-helper.cc	2024-02-09 14:44:08.605795100 -0800
+++ ns-3.42/src/wifi/model/wifi-phy-state-helper.cc	2024-05-29 15:29:47.212073800 -0700
@@ -55,6 +55,11 @@
                             "A packet has been received successfully.",
                             MakeTraceSourceAccessor(&WifiPhyStateHelper::m_rxOkTrace),
                             "ns3::WifiPhyStateHelper::RxOkTracedCallback")
+            .AddTraceSource(
+                "RxOutcome",
+                "The outcome of the decoding of the PPDU, including MPDU decoding status",
+                MakeTraceSourceAccessor(&WifiPhyStateHelper::m_rxOutcomeTrace),
+                "ns3::WifiPhyStateHelper::RxOutcomeTracedCallback")
             .AddTraceSource("RxError",
                             "A packet has been received unsuccessfuly.",
                             MakeTraceSourceAccessor(&WifiPhyStateHelper::m_rxErrorTrace),
@@ -70,16 +75,20 @@
     : NS_LOG_TEMPLATE_DEFINE("WifiPhyStateHelper"),
       m_sleeping(false),
       m_isOff(false),
-      m_endTx(Seconds(0)),
-      m_endRx(Seconds(0)),
-      m_endCcaBusy(Seconds(0)),
-      m_endSwitching(Seconds(0)),
-      m_startTx(Seconds(0)),
-      m_startRx(Seconds(0)),
-      m_startCcaBusy(Seconds(0)),
-      m_startSwitching(Seconds(0)),
-      m_startSleep(Seconds(0)),
-      m_previousStateChangeTime(Seconds(0))
+      m_endTx(Time{0}),
+      m_endRx(Time{0}),
+      m_endCcaBusy(Time{0}),
+      m_endSwitching(Time{0}),
+      m_endSleep(Time{0}),
+      m_endOff(Time{0}),
+      m_endIdle(Time{0}),
+      m_startTx(Time{0}),
+      m_startRx(Time{0}),
+      m_startCcaBusy(Time{0}),
+      m_startSwitching(Time{0}),
+      m_startSleep(Time{0}),
+      m_startOff(Time{0}),
+      m_previousStateChangeTime(Time{0})
 {
     NS_LOG_FUNCTION(this);
 }
@@ -195,9 +204,54 @@
     return m_endRx;
 }
 
+Time
+WifiPhyStateHelper::GetLastTime(std::initializer_list<WifiPhyState> states) const
+{
+    Time last{0};
+    auto currentState = GetState();
+
+    for (auto state : states)
+    {
+        if (state == currentState)
+        {
+            return Simulator::Now();
+        }
+
+        switch (state)
+        {
+        case WifiPhyState::RX:
+            last = std::max(last, m_endRx);
+            break;
+        case WifiPhyState::TX:
+            last = std::max(last, m_endTx);
+            break;
+        case WifiPhyState::CCA_BUSY:
+            last = std::max(last, m_endCcaBusy);
+            break;
+        case WifiPhyState::SWITCHING:
+            last = std::max(last, m_endSwitching);
+            break;
+        case WifiPhyState::SLEEP:
+            last = std::max(last, m_endSleep);
+            break;
+        case WifiPhyState::OFF:
+            last = std::max(last, m_endOff);
+            break;
+        case WifiPhyState::IDLE:
+            last = std::max(last, m_endIdle);
+            break;
+        default:
+            NS_FATAL_ERROR("Invalid WifiPhy state " << state);
+        }
+    }
+    NS_ASSERT(last <= Simulator::Now());
+    return last;
+}
+
 WifiPhyState
 WifiPhyStateHelper::GetState() const
 {
+    const auto now = Simulator::Now();
     if (m_isOff)
     {
         return WifiPhyState::OFF;
@@ -206,19 +260,19 @@
     {
         return WifiPhyState::SLEEP;
     }
-    else if (m_endTx > Simulator::Now())
+    else if (m_endTx > now)
     {
         return WifiPhyState::TX;
     }
-    else if (m_endRx > Simulator::Now())
+    else if (m_endRx > now)
     {
         return WifiPhyState::RX;
     }
-    else if (m_endSwitching > Simulator::Now())
+    else if (m_endSwitching > now)
     {
         return WifiPhyState::SWITCHING;
     }
-    else if (m_endCcaBusy > Simulator::Now())
+    else if (m_endCcaBusy > now)
     {
         return WifiPhyState::CCA_BUSY;
     }
@@ -232,28 +286,32 @@
 WifiPhyStateHelper::LogPreviousIdleAndCcaBusyStates()
 {
     NS_LOG_FUNCTION(this);
-    Time now = Simulator::Now();
+    const auto now = Simulator::Now();
     WifiPhyState state = GetState();
     if (state == WifiPhyState::CCA_BUSY)
     {
-        Time ccaStart = std::max({m_endRx, m_endTx, m_startCcaBusy, m_endSwitching});
+        m_endCcaBusy = now;
+        const auto ccaStart =
+            std::max({m_endRx, m_endTx, m_startCcaBusy, m_endSwitching, m_endSleep, m_endOff});
         m_stateLogger(ccaStart, now - ccaStart, WifiPhyState::CCA_BUSY);
     }
     else if (state == WifiPhyState::IDLE)
     {
-        Time idleStart = std::max({m_endCcaBusy, m_endRx, m_endTx, m_endSwitching});
+        m_endIdle = now;
+        const auto endAllButCcaBusy =
+            std::max({m_endRx, m_endTx, m_endSwitching, m_endSleep, m_endOff});
+        const auto idleStart = std::max(m_endCcaBusy, endAllButCcaBusy);
         NS_ASSERT(idleStart <= now);
-        if (m_endCcaBusy > m_endRx && m_endCcaBusy > m_endSwitching && m_endCcaBusy > m_endTx)
+        if (m_endCcaBusy > endAllButCcaBusy)
         {
-            Time ccaBusyStart = std::max({m_endTx, m_endRx, m_startCcaBusy, m_endSwitching});
-            Time ccaBusyDuration = idleStart - ccaBusyStart;
-            if (ccaBusyDuration.IsStrictlyPositive())
+            const auto ccaBusyStart = std::max(m_startCcaBusy, endAllButCcaBusy);
+            if (const auto ccaBusyDuration = idleStart - ccaBusyStart;
+                ccaBusyDuration.IsStrictlyPositive())
             {
                 m_stateLogger(ccaBusyStart, ccaBusyDuration, WifiPhyState::CCA_BUSY);
             }
         }
-        Time idleDuration = now - idleStart;
-        if (idleDuration.IsStrictlyPositive())
+        if (const auto idleDuration = now - idleStart; idleDuration.IsStrictlyPositive())
         {
             m_stateLogger(idleStart, idleDuration, WifiPhyState::IDLE);
         }
@@ -412,6 +470,16 @@
 }
 
 void
+WifiPhyStateHelper::NotifyRxPpduOutcome(Ptr<const WifiPpdu> ppdu,
+                                        RxSignalInfo rxSignalInfo,
+                                        const WifiTxVector& txVector,
+                                        uint16_t staId,
+                                        const std::vector<bool>& statusPerMpdu)
+{
+    m_rxOutcomeTrace(ppdu, rxSignalInfo, txVector, statusPerMpdu);
+}
+
+void
 WifiPhyStateHelper::SwitchFromRxEndOk()
 {
     NS_LOG_FUNCTION(this);
@@ -500,6 +568,7 @@
     m_stateLogger(m_startSleep, now - m_startSleep, WifiPhyState::SLEEP);
     m_previousStateChangeTime = now;
     m_sleeping = false;
+    m_endSleep = now;
     NotifyListeners(&WifiPhyListener::NotifyWakeup);
 }
 
@@ -556,6 +625,7 @@
     }
     m_previousStateChangeTime = now;
     m_isOff = true;
+    m_startOff = now;
     NotifyListeners(&WifiPhyListener::NotifyOff);
     NS_ASSERT(IsStateOff());
 }
@@ -568,6 +638,7 @@
     Time now = Simulator::Now();
     m_previousStateChangeTime = now;
     m_isOff = false;
+    m_endOff = now;
     NotifyListeners(&WifiPhyListener::NotifyOn);
 }
 
